%                     Universita' di Ferrara                       %
%                                                                  %
%                Corso di informatica industriale                  %
%                                                                  %
%                  funzione acquisti2 - esercizio 2                %
%                   Esercizi avanzati - 6/3/2009                   %
%******************************************************************%
%
%   function acquisti2(scontrini,nomi)
%
% Risolve l'esercizio avanzato 2, posti in ingresso la matrice scontrini ed
% il vettore nomi prodotti, aventi lo stesso numero di righe.
% scontrini: individua l'acquisto dei prodotti
% nomi: contiene i nomi dei prodotti

function acquisti2(scontrini,nomi)

%% punto 4

%Occorre conoscere la dimensione della matrice scontrini
[num_prodotti,num_scontrini]=size(scontrini);

%Inizializzo variabile resoconto
resoconto=[];

% calcolo la confidence dei prodotti presenti nello scontrino; per far cio'
% occorre prendere in considerazione ogni combinazione di coppie di due
% beni differenti
for i=1:num_prodotti
    for j=1:num_prodotti
        if i==j % Nel caso siano uguali
            continue % non fare nulla
        end
        %Calcolo confidence
        confidence=acquisticombinati(scontrini,i,j)/acquisti(scontrini,i);
        %aggiorno la matrice resoconto
        resoconto=[resoconto;i,j,confidence];
    end
end

%% punto 5

%ordinamento vettore resoconto
resoconto=sortrows(resoconto,3);
resoconto=flipud(resoconto);

% Visualizzazione coppie con confidence elevata
for i=1:10      %le prime 10
    %Si scelgono i primi prodotti in resoconto
    codice_uno=resoconto(i,1);
    codice_due=resoconto(i,2);
    %Conversione per le stringhe, per visualizzare in nomi
    prodotto_uno=char(nomi(codice_uno));
    prodotto_due=char(nomi(codice_due));
    %Si seleziona la confidence dei due prodotti
    confidence=resoconto(i,3);
    %stampo a video
    fprintf(1,'%s \t %s \t %g \n',prodotto_uno ,prodotto_due,confidence);
end
end

%-------------------- Fine funzione acquisti2 ---------------------------%

%% function n=acquisti(A,x)
% punto 2: funzione che, noto indice e matrice, ricava la somma degli
% acquisti effettuati riferiti a quello scontrino

function n=acquisti(A,x)

acquisti_x=A(x,:);
n=sum(acquisti_x);

end

%% function n=acquisticombinati(A,x,y)
% punto 3: ricava il numero degli acquisti in comune con due oggetti

function n=acquisticombinati(A,x,y)

%seleziono i due prodotti differenti
acquisti_x=A(x,:);
acquisti_y=A(y,:);

acquisti_entrambi=(acquisti_x&acquisti_y); %indicizzo sugli elementi comuni

n=sum(acquisti_entrambi); %computo la somma
end

